import { parsePath, createPath, createMemoryHistory, createBrowserHistory, createHashHistory } from 'history';
import { match as match$1 } from 'path-to-regexp';
import { useContext, createContext, useState, useRef, useMemo, useEffect } from 'react';
import { jsx, jsxs, Fragment } from 'react/jsx-runtime';

function _toConsumableArray$2(arr) {
  return _arrayWithoutHoles$2(arr) || _iterableToArray$2(arr) || _unsupportedIterableToArray$4(arr) || _nonIterableSpread$2();
}
function _nonIterableSpread$2() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _iterableToArray$2(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _arrayWithoutHoles$2(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray$4(arr);
}
function _slicedToArray$4(arr, i) {
  return _arrayWithHoles$4(arr) || _iterableToArrayLimit$4(arr, i) || _unsupportedIterableToArray$4(arr, i) || _nonIterableRest$4();
}
function _nonIterableRest$4() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray$4(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray$4(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray$4(o, minLen);
}
function _arrayLikeToArray$4(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit$4(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s, _e, _x, _r, _arr = [], _n = true, _d = false;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i)
          return;
        _n = false;
      } else
        for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = true)
          ;
    } catch (err) {
      _d = true, _e = err;
    } finally {
      try {
        if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r))
          return;
      } finally {
        if (_d)
          throw _e;
      }
    }
    return _arr;
  }
}
function _arrayWithHoles$4(arr) {
  if (Array.isArray(arr))
    return arr;
}
function createStateContext() {
  for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
    params[_key] = arguments[_key];
  }
  var ValueContext = /* @__PURE__ */ createContext(void 0);
  var SetterContext = /* @__PURE__ */ createContext(void 0);
  function Provider(_ref) {
    var children = _ref.children;
    var _useState = useState.apply(void 0, _toConsumableArray$2(params)), _useState2 = _slicedToArray$4(_useState, 2), value = _useState2[0], setValue = _useState2[1];
    return /* @__PURE__ */ jsx(SetterContext.Provider, {
      value: setValue,
      children: /* @__PURE__ */ jsx(ValueContext.Provider, {
        value,
        children
      })
    });
  }
  return {
    SetterContext,
    ValueContext,
    Provider
  };
}
function useValueContext(Ctx) {
  return useContext(Ctx.ValueContext);
}
function useSetterContext(Ctx) {
  return useContext(Ctx.SetterContext);
}

function _typeof$3(obj) {
  "@babel/helpers - typeof";
  return _typeof$3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof$3(obj);
}
function _slicedToArray$3(arr, i) {
  return _arrayWithHoles$3(arr) || _iterableToArrayLimit$3(arr, i) || _unsupportedIterableToArray$3(arr, i) || _nonIterableRest$3();
}
function _nonIterableRest$3() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray$3(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray$3(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray$3(o, minLen);
}
function _arrayLikeToArray$3(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit$3(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s, _e, _x, _r, _arr = [], _n = true, _d = false;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i)
          return;
        _n = false;
      } else
        for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = true)
          ;
    } catch (err) {
      _d = true, _e = err;
    } finally {
      try {
        if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r))
          return;
      } finally {
        if (_d)
          throw _e;
      }
    }
    return _arr;
  }
}
function _arrayWithHoles$3(arr) {
  if (Array.isArray(arr))
    return arr;
}
function ownKeys$3(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread$3(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$3(Object(source), true).forEach(function(key) {
      _defineProperty$3(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$3(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$3(obj, key, value) {
  key = _toPropertyKey$3(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$3(arg) {
  var key = _toPrimitive$3(arg, "string");
  return _typeof$3(key) === "symbol" ? key : String(key);
}
function _toPrimitive$3(input, hint) {
  if (_typeof$3(input) !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (_typeof$3(res) !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var ViewContext = /* @__PURE__ */ createContext(null);
function ViewProvider(props) {
  return /* @__PURE__ */ jsx(ViewContext.Provider, _objectSpread$3({}, props));
}
function useView() {
  return useContext(ViewContext);
}
function View() {
  return useView();
}
function InitializableView(_ref) {
  var initial = _ref.initial;
  var view = useView();
  var ref = useRef(view);
  if (view === ref.current && !view)
    return initial;
  ref.current = Symbol("");
  return view;
}
var DataContext = /* @__PURE__ */ createContext([void 0, {}]);
function useDataContext() {
  return useContext(DataContext);
}
function useNamedData() {
  return useDataContext()[1];
}
function DataProvider(_ref2) {
  var children = _ref2.children, name = _ref2.name, data = _ref2.data;
  var namedData = useNamedData();
  var value = useMemo(function() {
    return [data, name ? _objectSpread$3(_objectSpread$3({}, namedData), {}, _defineProperty$3({}, name, data)) : namedData];
  }, [data, name, namedData]);
  return /* @__PURE__ */ jsx(DataContext.Provider, {
    value,
    children
  });
}
var MatchedContext = /* @__PURE__ */ createContext(void 0);
function useMatched() {
  return useContext(MatchedContext);
}
function useData(name) {
  var _useDataContext = useDataContext(), _useDataContext2 = _slicedToArray$3(_useDataContext, 2), data = _useDataContext2[0], namedData = _useDataContext2[1];
  return name ? namedData[name] : data;
}
var LoadingContext = createStateContext();
function useLoading() {
  return useValueContext(LoadingContext);
}
function useLoadingSetter() {
  return useSetterContext(LoadingContext);
}

var i = 1;
function uniqId() {
  return i++;
}
function noop() {
}
Promise.resolve.bind(Promise);
var reject = Promise.reject.bind(Promise);
function cancelPromise() {
  return new Promise(noop);
}
function createCurrentGuard() {
  var current;
  return [function currentGuard(promise) {
    var cur = uniqId();
    current = cur;
    return promise.then(function(result) {
      return current === cur ? result : cancelPromise();
    }).catch(function(err) {
      return current === cur ? Promise.reject(err) : cancelPromise();
    });
  }, function cancel() {
    current = void 0;
  }];
}

function _typeof$2(obj) {
  "@babel/helpers - typeof";
  return _typeof$2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof$2(obj);
}
function _toConsumableArray$1(arr) {
  return _arrayWithoutHoles$1(arr) || _iterableToArray$1(arr) || _unsupportedIterableToArray$2(arr) || _nonIterableSpread$1();
}
function _nonIterableSpread$1() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _iterableToArray$1(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _arrayWithoutHoles$1(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray$2(arr);
}
function ownKeys$2(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread$2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$2(Object(source), true).forEach(function(key) {
      _defineProperty$2(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$2(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$2(obj, key, value) {
  key = _toPropertyKey$2(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$2(arg) {
  var key = _toPrimitive$2(arg, "string");
  return _typeof$2(key) === "symbol" ? key : String(key);
}
function _toPrimitive$2(input, hint) {
  if (_typeof$2(input) !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (_typeof$2(res) !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function _slicedToArray$2(arr, i) {
  return _arrayWithHoles$2(arr) || _iterableToArrayLimit$2(arr, i) || _unsupportedIterableToArray$2(arr, i) || _nonIterableRest$2();
}
function _nonIterableRest$2() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray$2(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray$2(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray$2(o, minLen);
}
function _arrayLikeToArray$2(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit$2(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s, _e, _x, _r, _arr = [], _n = true, _d = false;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i)
          return;
        _n = false;
      } else
        for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = true)
          ;
    } catch (err) {
      _d = true, _e = err;
    } finally {
      try {
        if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r))
          return;
      } finally {
        if (_d)
          throw _e;
      }
    }
    return _arr;
  }
}
function _arrayWithHoles$2(arr) {
  if (Array.isArray(arr))
    return arr;
}
function create(routes, history, resolveView, options) {
  var _createCurrentGuard = createCurrentGuard(), _createCurrentGuard2 = _slicedToArray$2(_createCurrentGuard, 2), currentGuard = _createCurrentGuard2[0], cancelAll = _createCurrentGuard2[1];
  return _objectSpread$2(_objectSpread$2({
    routes: Array.isArray(routes) ? routes : [routes],
    resolveView,
    history,
    locationStack: [],
    viewStack: [],
    currentGuard,
    cancelAll,
    errorHandler: reject
  }, options), {}, {
    baseUrl: (options === null || options === void 0 ? void 0 : options.baseUrl) || ""
  });
}
function match(router, pathname) {
  function matchRoutes(routes, baseUrl, pathname2) {
    for (var i = 0; i < routes.length; i++) {
      var route = routes[i];
      var end = !route.children;
      var matched = route.path ? match$1(route.path, {
        strict: true,
        sensitive: true,
        decode: typeof decodeURIComponent === "function" ? decodeURIComponent : void 0,
        end
      })(pathname2) : {
        path: "",
        index: 0,
        params: {}
      };
      if (matched) {
        var result = _objectSpread$2({
          route
        }, matched);
        if (end)
          return [result];
        var children = matchRoutes(route.children, "".concat(baseUrl).concat(route.path || ""), pathname2.slice(matched.path.length));
        if (children)
          return [result].concat(_toConsumableArray$1(children));
        return void 0;
      }
    }
    return void 0;
  }
  return matchRoutes(router.routes, router.baseUrl, pathname.slice(router.baseUrl.length));
}
function toLocation(router, to, state) {
  var baseUrl = router.baseUrl;
  return _objectSpread$2(_objectSpread$2({
    pathname: "",
    search: "",
    hash: ""
  }, parsePath(baseUrl + to)), {}, {
    state
  });
}
function resolve(router, location) {
  var matched = match(router, location.pathname);
  var resolveView = router.resolveView, errorHandler = router.errorHandler;
  return (matched ? resolveView(matched, {
    router,
    location
  }) : (
    // TODO: Custom Error
    Promise.reject(new Error("Not Found"))
  )).catch(errorHandler);
}
function resolveTo(router, to, state) {
  var location = toLocation(router, to, state);
  return resolve(router, location);
}
function commit(router, resolvePromise, location) {
  var _history$location$sta;
  var history = router.history, currentGuard = router.currentGuard, _router$onLoadingChan = router.onLoadingChange, onLoadingChange = _router$onLoadingChan === void 0 ? noop : _router$onLoadingChan;
  var nextIndex = (((_history$location$sta = history.location.state) === null || _history$location$sta === void 0 ? void 0 : _history$location$sta.index) || 0) + 1;
  if (router.resolving) {
    onLoadingChange();
  }
  router.resolving = location;
  onLoadingChange("pending");
  return currentGuard(resolvePromise).then(function(resolvedView) {
    router.locationStack = [].concat(_toConsumableArray$1(router.locationStack.slice(0, nextIndex)), [location]);
    router.viewStack = [].concat(_toConsumableArray$1(router.viewStack.slice(0, nextIndex)), [resolvedView]);
    history.push(location, {
      index: nextIndex,
      locationStack: router.locationStack
    });
    onLoadingChange("resolved");
  }).catch(function(e) {
    onLoadingChange("rejected");
    throw e;
  });
}
function commitReplace(router, resolvePromise, location) {
  var _history$location$sta2;
  var history = router.history, currentGuard = router.currentGuard, _router$onLoadingChan2 = router.onLoadingChange, onLoadingChange = _router$onLoadingChan2 === void 0 ? noop : _router$onLoadingChan2;
  var index = ((_history$location$sta2 = history.location.state) === null || _history$location$sta2 === void 0 ? void 0 : _history$location$sta2.index) || 0;
  if (router.resolving) {
    onLoadingChange();
  }
  router.resolving = location;
  onLoadingChange("pending");
  return currentGuard(resolvePromise).then(function(resolvedView) {
    router.locationStack[index] = location;
    router.viewStack[index] = resolvedView;
    history.replace(location, {
      index,
      locationStack: router.locationStack
    });
    onLoadingChange("resolved");
  }).catch(function(e) {
    onLoadingChange("rejected");
    throw e;
  });
}
function navigate(router, to, state) {
  var location = toLocation(router, to, state);
  var viewPromise = resolve(router, location);
  return commit(router, viewPromise, location);
}
function refresh(router) {
  var location = router.history.location;
  var viewPromise = resolve(router, location);
  return commitReplace(router, viewPromise, location);
}
function go(router, delta) {
  router.history.go(delta);
}
function forward(router) {
  router.history.forward();
}
function back(router) {
  router.history.back();
}
function createHref(_ref, to) {
  var baseUrl = _ref.baseUrl, history = _ref.history;
  return baseUrl + history.createHref(to);
}
function cancel(_ref2) {
  var cancelAll = _ref2.cancelAll, _ref2$onLoadingChange = _ref2.onLoadingChange, onLoadingChange = _ref2$onLoadingChange === void 0 ? noop : _ref2$onLoadingChange;
  cancelAll();
  onLoadingChange();
}
function listen(router, onViewChange) {
  var _history$location$sta3;
  var _router$onLoadingChan3 = router.onLoadingChange, onLoadingChange = _router$onLoadingChan3 === void 0 ? noop : _router$onLoadingChan3, history = router.history;
  var locationStack = ((_history$location$sta3 = history.location.state) === null || _history$location$sta3 === void 0 ? void 0 : _history$location$sta3.locationStack) || [history.location];
  router.locationStack = locationStack;
  onLoadingChange("pending");
  Promise.all(locationStack.map(function(l) {
    return resolve(router, l);
  })).then(function(views) {
    router.viewStack = views;
    history.replace(createPath(history.location), history.location.state);
    onLoadingChange("resolved");
  }).catch(function(e) {
    onLoadingChange("rejected");
    throw e;
  });
  var rmListener = history.listen(function(_ref3) {
    var action = _ref3.action, location = _ref3.location;
    cancel(router);
    var state = location.state;
    var index = (state === null || state === void 0 ? void 0 : state.index) || 0;
    onViewChange(router.viewStack[index]);
    if (action === "POP") {
      history.replace(createPath(history.location), _objectSpread$2(_objectSpread$2({}, state), {}, {
        locationStack: router.locationStack
      }));
    }
  });
  return function() {
    cancel(router);
    rmListener();
  };
}

function _slicedToArray$1(arr, i) {
  return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _unsupportedIterableToArray$1(arr, i) || _nonIterableRest$1();
}
function _nonIterableRest$1() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray$1(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray$1(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray$1(o, minLen);
}
function _arrayLikeToArray$1(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit$1(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s, _e, _x, _r, _arr = [], _n = true, _d = false;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i)
          return;
        _n = false;
      } else
        for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = true)
          ;
    } catch (err) {
      _d = true, _e = err;
    } finally {
      try {
        if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r))
          return;
      } finally {
        if (_d)
          throw _e;
      }
    }
    return _arr;
  }
}
function _arrayWithHoles$1(arr) {
  if (Array.isArray(arr))
    return arr;
}
function resolveView(matched, ctx) {
  return resolveViewBase(matched, ctx, function(data, dataCtx) {
    return data === null || data === void 0 ? void 0 : data(dataCtx);
  });
}
var viewDataMap = /* @__PURE__ */ new WeakMap();
function resolveViewServer(matched, ctx) {
  var dataResults = new Array(matched.length);
  return resolveViewBase(matched, ctx, function(data, dataCtx) {
    return Promise.resolve(data === null || data === void 0 ? void 0 : data(dataCtx)).then(function(result) {
      return dataResults[dataCtx.index] = result;
    });
  }).then(function(view) {
    viewDataMap.set(view, dataResults);
    return view;
  });
}
function createHydrateResolveView(data) {
  return function(matched, ctx) {
    return resolveViewBase(matched, ctx, function(_, dataCtx) {
      return data[dataCtx.index];
    });
  };
}
function getViewData(view) {
  return viewDataMap.get(view);
}
function resolveViewBase(matched, _ref, resolveData) {
  var router = _ref.router, location = _ref.location;
  return Promise.all(matched.map(function(_ref2, index) {
    var params = _ref2.params, route = _ref2.route;
    var ctx = {
      matched,
      params,
      index,
      router,
      location
    };
    function resolveComponent() {
      if (!route.component)
        return View;
      var r = route.component(ctx);
      return Promise.resolve(r).then(function(m) {
        return "default" in m ? m.default : m;
      });
    }
    return Promise.all([resolveData(route.data, ctx), resolveComponent()]).then(function(_ref3) {
      var _ref4 = _slicedToArray$1(_ref3, 2), data = _ref4[0], C = _ref4[1];
      return /* @__PURE__ */ jsx(DataProvider, {
        data,
        name: route.name,
        children: /* @__PURE__ */ jsx(MatchedContext.Provider, {
          value: ctx,
          children: /* @__PURE__ */ jsx(C, {})
        })
      });
    });
  })).then(function(views) {
    return views.reverse().reduce(function(acc, view) {
      return /* @__PURE__ */ jsx(ViewProvider, {
        value: acc,
        children: view
      });
    });
  });
}

function _typeof$1(obj) {
  "@babel/helpers - typeof";
  return _typeof$1 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof$1(obj);
}
var _excluded = ["resolveView"], _excluded2 = ["router"], _excluded3 = ["children", "routes"], _excluded4 = ["children", "routes"], _excluded5 = ["initialEntries", "initialIndex", "children", "routes"];
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray(arr);
}
function ownKeys$1(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$1(Object(source), true).forEach(function(key) {
      _defineProperty$1(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$1(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$1(obj, key, value) {
  key = _toPropertyKey$1(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$1(arg) {
  var key = _toPrimitive$1(arg, "string");
  return _typeof$1(key) === "symbol" ? key : String(key);
}
function _toPrimitive$1(input, hint) {
  if (_typeof$1(input) !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (_typeof$1(res) !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s, _e, _x, _r, _arr = [], _n = true, _d = false;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i)
          return;
        _n = false;
      } else
        for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = true)
          ;
    } catch (err) {
      _d = true, _e = err;
    } finally {
      try {
        if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r))
          return;
      } finally {
        if (_d)
          throw _e;
      }
    }
    return _arr;
  }
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr))
    return arr;
}
var RouterContext = /* @__PURE__ */ createContext(null);
function BRouter(_ref) {
  var children = _ref.children;
  var setLoading = useLoadingSetter();
  var router = useRouter();
  router.onLoadingChange = function(status) {
    setLoading(status && {
      key: uniqId(),
      status
    });
  };
  var _useState = useState(), _useState2 = _slicedToArray(_useState, 2), view = _useState2[0], setView = _useState2[1];
  useEffect(function() {
    return listen(router, setView);
  }, [router]);
  return children === "undefined" ? view : /* @__PURE__ */ jsx(ViewProvider, {
    value: view,
    children
  });
}
function createRouter(routes, history) {
  var _ref2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, _ref2$resolveView = _ref2.resolveView, resolveView$1 = _ref2$resolveView === void 0 ? resolveView : _ref2$resolveView, options = _objectWithoutProperties(_ref2, _excluded);
  return create(routes, history, resolveView$1, options);
}
function Router(_ref3) {
  var router = _ref3.router, props = _objectWithoutProperties(_ref3, _excluded2);
  return /* @__PURE__ */ jsx(LoadingContext.Provider, {
    children: /* @__PURE__ */ jsx(RouterContext.Provider, {
      value: router,
      children: /* @__PURE__ */ jsx(BRouter, _objectSpread$1({}, props))
    })
  });
}
function useNewRouter(routes, createHistory, options) {
  return useMemo(function() {
    return createRouter(routes, createHistory(), options);
  }, [routes, createHistory].concat(_toConsumableArray(Object.keys(options)), _toConsumableArray(Object.values(options))));
}
function HistoryRouter(_ref4) {
  var children = _ref4.children, routes = _ref4.routes, options = _objectWithoutProperties(_ref4, _excluded3);
  var router = useNewRouter(routes, createBrowserHistory, options);
  return /* @__PURE__ */ jsx(Router, {
    router,
    children
  });
}
function HashRouter(_ref5) {
  var children = _ref5.children, routes = _ref5.routes, options = _objectWithoutProperties(_ref5, _excluded4);
  var router = useNewRouter(routes, createHashHistory, options);
  return /* @__PURE__ */ jsx(Router, {
    router,
    children
  });
}
function MemoryRouter(_ref6) {
  var initialEntries = _ref6.initialEntries, initialIndex = _ref6.initialIndex, children = _ref6.children, routes = _ref6.routes, options = _objectWithoutProperties(_ref6, _excluded5);
  var createHistory = useMemo(function() {
    return function() {
      return createMemoryHistory({
        initialEntries,
        initialIndex
      });
    };
  }, [initialEntries, initialIndex]);
  var router = useNewRouter(routes, createHistory, options);
  return /* @__PURE__ */ jsx(Router, {
    router,
    children
  });
}
function useRouter() {
  return useContext(RouterContext);
}

function _typeof(obj) {
  "@babel/helpers - typeof";
  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof(obj);
}
function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return _typeof(key) === "symbol" ? key : String(key);
}
function _toPrimitive(input, hint) {
  if (_typeof(input) !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (_typeof(res) !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var defaultHydrateKey = "_nativeRouterReactSSRData";
function resolveServerView(routes, location, options) {
  var router = create(routes, createMemoryHistory(), resolveViewServer, options);
  return resolve(router, location).then(function(view) {
    var data = getViewData(view);
    return /* @__PURE__ */ jsxs(Fragment, {
      children: [/* @__PURE__ */ jsx(Router, {
        router,
        children: view
      }), /* @__PURE__ */ jsx("script", _objectSpread(_objectSpread({}, options === null || options === void 0 ? void 0 : options.scriptAttributes), {}, {
        suppressHydrationWarning: true,
        dangerouslySetInnerHTML: {
          __html: "window.".concat((options === null || options === void 0 ? void 0 : options.hydrateKey) || defaultHydrateKey, " = ").concat(JSON.stringify({
            data,
            location
          }), ";")
        }
      }))]
    });
  });
}
function resolveClientView(routes, options) {
  var _ref = window[(options === null || options === void 0 ? void 0 : options.hydrateKey) || defaultHydrateKey], data = _ref.data, location = _ref.location;
  var router = create(routes, createMemoryHistory(), createHydrateResolveView(data), options);
  return resolve(router, location);
}

export { HistoryRouter as H, InitializableView as I, MemoryRouter as M, Router as R, View as V, commit as a, useView as b, createHref as c, useData as d, useLoading as e, useMatched as f, resolveView as g, resolveClientView as h, createRouter as i, HashRouter as j, create as k, resolveTo as l, match as m, navigate as n, commitReplace as o, refresh as p, go as q, resolve as r, forward as s, toLocation as t, useRouter as u, back as v, cancel as w, listen as x, resolveServerView as y };
//# sourceMappingURL=server-bdd540c4.mjs.map
